#!/usr/bin/env node
import p from "node:path";
import u from "node:fs";
import h from "lodash.upperfirst";
import y from "lodash.camelcase";
import $ from "lodash.kebabcase";
import A from "lodash.lowerfirst";
import d from "lodash.template";
import { log as m, json5 as L, chalk as D, xPrompts as w, _curry as b, createSubcommand as M, getRootScriptName as j, createMainCommand as F } from "@done-coding/cli-utils";
import { OutputModeEnum as S, compileHandler as N } from "@done-coding/cli-template";
var a = /* @__PURE__ */ ((e) => (e.ADD = "add", e.REMOVE = "remove", e.LIST = "list", e))(a || {});
const T = (e, t) => {
  if (!/^[a-zA-Z]+[a-zA-Z0-9-]*$/.test(e))
    return m.error("组件名只能包含字母、数字、中划线"), process.exit(1);
  const { nameExcludes: n } = t;
  return n.includes(e) ? (m.error(`组件名: ${e}是保留名称。
保留名称: ${n.join(",")}`), process.exit(1)) : !0;
}, C = {
  name: "@done-coding/cli-component",
  version: "0.3.12-alpha.0",
  description: "组件命令行工具",
  bin: {
    "dc-component": "es/cli.mjs"
  },
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "component"
  }
}, { namespaceDir: _, moduleName: K } = C.cliConfig, R = () => p.resolve(_, K), I = () => ({
  execDir: process.cwd(),
  templateDir: R()
}), g = (e) => {
  const { series: t, name: n } = e, o = h(y(n)), i = A(o), s = $(o), c = t ? h(y(t)) : "", l = c ? `${c}${o}` : "", r = $(l);
  return {
    series: c,
    name: o,
    nameLowerFirst: i,
    nameKebab: s,
    fullName: l,
    fullNameKebab: r,
    cls: r
  };
}, J = (e) => ({
  $: "$",
  ...I(),
  ...g(e)
}), E = () => {
  const e = p.resolve(R(), "index.json");
  if (!u.existsSync(e))
    return m.error(`模块入口文件不存在: ${e}`), process.exit(1);
  const n = JSON.parse(u.readFileSync(e, "utf-8")).config;
  if (!n)
    return m.error(`配置文件相对路径不存在: ${n}`), process.exit(1);
  const o = p.resolve(
    p.dirname(e),
    n
  );
  if (!u.existsSync(o))
    return m.error(`配置文件不存在: ${o}`), process.exit(1);
  const i = L.parse(u.readFileSync(o, "utf-8")), s = I();
  return i.componentDir = d(i.componentDir)(s), i;
}, v = (e) => {
  const { componentDir: t, nameExcludes: n } = e;
  return u.statSync(t).isDirectory() ? u.readdirSync(t).map((c) => {
    const l = p.join(t, c);
    return u.statSync(l).isDirectory() ? (console.log("filePath:", l, p.basename(l)), p.basename(l)) : "";
  }).filter((c) => !(!c || n.includes(c))) : (m.error("组件源码路径不是目录"), process.exit(1));
}, z = async () => {
  m.stage("展示列表");
  const e = E(), t = v(e);
  console.table(
    t.map((n) => {
      const { name: o, fullName: i } = g({
        ...e,
        name: n
      });
      return {
        [D.green("名称")]: o,
        [D.green("带系列名称")]: i,
        [D.green("绝对路径")]: p.resolve(e.componentDir, n)
      };
    })
  );
}, P = async ({
  name: e,
  config: t,
  command: n
}) => {
  if (![a.ADD, a.REMOVE].includes(n))
    return m.error(`不支持组件${n}操作`), process.exit(1);
  const o = J({
    ...t,
    name: e
  }), i = process.cwd(), s = JSON.stringify(o);
  for (const { entry: c, index: l } of t.list) {
    if (c) {
      const r = c;
      r != null && r.input && (r.input = d(r.input)(o)), r != null && r.output && (r.output = d(r.output)(o));
      const f = {
        ...c,
        envData: s,
        mode: S.APPEND,
        rollback: n === a.REMOVE,
        /** 回滚时可以删除空文件 */
        rollbackDelNullFile: !0,
        dealMarkdown: !0,
        batch: !1,
        rootDir: i
      };
      await N(f);
    }
    if (l) {
      const r = l;
      r != null && r.input && (r.input = d(r.input)(o)), r != null && r.output && (r.output = d(r.output)(o));
      const f = {
        ...l,
        envData: s,
        mode: S.OVERWRITE,
        rollback: n === a.REMOVE,
        dealMarkdown: !0,
        batch: !1,
        rootDir: i
      };
      await N(f);
    }
  }
}, Z = async ({ name: e }) => {
  m.stage("添加组件");
  let t;
  e ? t = e : t = (await w({
    type: "text",
    name: "name",
    message: "请输入组件名"
  })).name;
  const n = E();
  T(t, n);
  const { series: o } = n, i = await v(n);
  for (let s of i)
    if (g({
      series: o,
      name: t
    }).nameKebab === s)
      return m.error(`组件${s}已存在, 不能再次创建${t}组件`), process.exit(1);
  return P({
    name: t,
    config: n,
    command: a.ADD
  });
}, H = async ({ name: e }) => {
  m.stage("移除组件");
  const t = E(), n = await v(t);
  if (n.length === 0)
    return m.error("组件列表为空"), process.exit(1);
  let o;
  e ? o = e : o = (await w({
    type: "select",
    name: "name",
    message: "请选择要移除的组件",
    choices: n.map((s) => ({ title: s, value: s }))
  })).name;
  const { series: i } = t;
  for (let s of n)
    if (g({
      series: i,
      name: o
    }).nameKebab === s) {
      await P({
        name: o,
        config: t,
        command: a.REMOVE
      }), u.rmdirSync(p.resolve(t.componentDir, s));
      return;
    }
  return m.error(`组件${o}不存在`), process.exit(1);
}, x = async (e, t) => e === a.ADD ? Z(t) : e === a.REMOVE ? H(t) : e === a.LIST ? z() : (m.error(`无效的命令: ${e}`), process.exit(1)), {
  version: U,
  description: W,
  cliConfig: { moduleName: O }
} = C, q = {
  command: `${a.ADD} <name>`,
  describe: "新增一个组件",
  positionals: {
    name: {
      describe: "组件名称",
      type: "string"
    }
  },
  handler: b(x)(a.ADD)
}, B = {
  command: `${a.REMOVE} [name]`,
  describe: "删除一个组件",
  positionals: {
    name: {
      describe: "组件名称",
      type: "string"
    }
  },
  handler: b(x)(a.REMOVE)
}, G = {
  command: a.LIST,
  describe: "展示组件列表",
  handler: b(x)(a.LIST)
}, V = {
  describe: W,
  version: U,
  subcommands: [
    q,
    B,
    G
  ].map(M),
  demandCommandCount: 1,
  rootScriptName: j({ packageJson: C })
}, k = (e = !1) => {
  const t = e ? O : void 0, n = `$0${e ? ` ${O}` : ""} <command> [options]`;
  return { command: t, usage: n };
}, ae = async () => F({
  ...V,
  ...k()
}), ie = () => M({
  ...V,
  ...k(!0)
});
export {
  ie as a,
  ae as c,
  x as h
};
